﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Net;

namespace PYRefresh
{
    /// <summary>
    /// If you want to add a plant you need to add a copydb database to the sql server add rows to the copyparams table
    /// then add the plant to the ddlPlants dropdown and add a connection string to the web.config
    /// </summary>
    public partial class _Default : Page
    {
        
       // public string userComputer { get; set; }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack )
            {
                try
                {
                    string userName = Request.LogonUserIdentity.Name;
                    if (!string.IsNullOrEmpty(userName))
                    {
                        lblUser.Text = "Logged in as: " + userName;
                        ViewState["UserName"] = userName;
                    }
                    //string IPAddress = Request.UserHostAddress;
                    //if (IPAddress != "::1")
                    //{//now localhost
                    //    IPHostEntry tmp = Dns.GetHostEntry(IPAddress);
                    //    userComputer = tmp.HostName;
                    //    if (!string.IsNullOrEmpty(userComputer))
                    //    {
                    //        lblComputer.Text = "Computer name: " + userComputer;
                    //    }
                    //}

                }
                catch (Exception)
                { }
            }
            lblError.Visible = false;
            lblError.Text = string.Empty;
        }

        protected void ddlPlants_SelectedIndexChanged(object sender, EventArgs e)
        {//This happens when a plant is selected from the dropdown

            RefreshData();
            
        }

        /// <summary>
        /// This sub will return the connection string
        /// </summary>
        /// <returns></returns>
        private string GetConnection()
        {
            string connStr = string.Empty;
            try
            {
                connStr = ConfigurationManager.ConnectionStrings[ddlPlants.SelectedItem.Text].ToString();
            }
            catch (Exception )
            {
                lblError.Text = "Plant Connection not found.";
                lblError.Visible = true;
            }
            return connStr;
        }

        /// <summary>
        /// This sub will refresh the grid based off the plant selected from the dropdown
        /// </summary>
        private void RefreshData()
        {
            gvDB.DataSource = null;
            gvDB.DataBind();
            if (ddlPlants.SelectedIndex != -1 && !string.IsNullOrEmpty(ddlPlants.SelectedItem.Text))
            {
                string connString = GetConnection();

                //System.Security.Principal.WindowsImpersonationContext impersonationContext;
                //impersonationContext =
                //    ((System.Security.Principal.WindowsIdentity)User.Identity).Impersonate();

                //Insert your code that runs under the security context of the authenticating user here.

                
                DataSet ds = DataUtils.GetDataSet(connString, "usp_PYRefreshSelect", CommandType.StoredProcedure);
                //impersonationContext.Undo();
                if (ds != null && ds.Tables.Count > 0)
                {
                   // gvDB.AutoGenerateColumns = true;
                    gvDB.DataSource = ds;
                    gvDB.DataBind();

                }

            }
        }

        /// <summary>
        /// refresh button click
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnRefresh_Click(object sender, EventArgs e)
        {
            RefreshData();
        }

        /// <summary>
        /// clicking the edit link
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void gvDB_RowEditing(object sender, GridViewEditEventArgs e)
        {
            gvDB.EditIndex = e.NewEditIndex;
            RefreshData();
        }

        /// <summary>
        /// clicking the cancel link
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void gvDB_RowCancelingEdit(object sender, GridViewCancelEditEventArgs e)
        {
            e.Cancel = true;
            gvDB.EditIndex = -1;
            RefreshData();
        }

        /// <summary>
        /// clicking the update link
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void gvDB_RowUpdating(object sender, GridViewUpdateEventArgs e)
        {
            GridViewRow row = gvDB.Rows[e.RowIndex];
            long key = long.Parse(gvDB.DataKeys[e.RowIndex].Value.ToString());
            CheckBox NeedProcess = (CheckBox)row.FindControl("chkBoxNeedProcess");
            //CheckBox DoAbort = (CheckBox)row.FindControl("chkBoxAbort");

            string connString = GetConnection();

            SqlParameter[] param = new SqlParameter[3] { new SqlParameter("@CopyParamsID", key), new SqlParameter("@NeedProcess", NeedProcess.Checked),
            new SqlParameter("@userName",ViewState["UserName"].ToString() )};


            DataUtils.GetExecNonQry(connString, "usp_PYRefreshUpdate", CommandType.StoredProcedure, ref param);

            
            e.Cancel = true;
            gvDB.EditIndex = -1;
            RefreshData();
        }

        protected void btnStartJob_Click(object sender, EventArgs e)
        { //Not used because sql job runs every minute
            string connString = GetConnection();
            DataUtils.GetExecNonQry(connString, "exec msdb.dbo.sp_start_job @job_name = 'RefreshTest'", CommandType.Text);
        }
    }
}